$(document).ready(async function () {
  const permissaoUsuarioLogado = await permissaoAcessos("CLAFISCAL");

  // autocompleta
  $("#txtNCMconsulta").autocompleta(
    1,
    `JSON={ "tabela":"tabfis", "camposSelect":[ "codigo chave", "tipo descricao"], "where": null}`
  );
  // pesquisa
  $("#btn-NCM").pesquisa(
    "#txtNCMconsulta",
    "CODIGO",
    "TIPO",
    `/sisplan/funcoes/v1/pesquisa?JSON={ "tabela":"tabfis", "camposSelect":[ "codigo", "tipo"]}`,
    "Pesquisa NCM",
    "tabfis"
  );
  // limpaCampo
  $("#btn-limpa-NCM").on("click", function () {
    $("#txtNCMconsulta").val("");
  });

  function retornaBotaoOpcoes(data) {
    var retorno = '<div style="text-align:start;"> ' +
      '    <button class="btn btn-info btn-sm dropdown-toggle btnVerificaOpcoes" type="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false"> ' +
      '      ' + data + ' ' +
      '    </button> ' +
      '    <div class="dropdown-menu"> ' +
      '    <button class="dropdown-item" type="button" title="Editar" id="btn-editar">Editar</button>     ' +
      '    <button class="dropdown-item" type="button" title="Excluir" id="btn-excluir">Excluir</button>  ' +
      '</div>';
    return retorno;
  };

  ConsultaNCM();

  $("#btnFiltros").on("click", async function () {
    $("#modal-filtros").modal("show");
  });

  $("#btnNovaClaFiscal").on("click", async function () {
    if (permissaoUsuarioLogado.INCLUI == 'S') {
      window.location.href = "clafiscal/create";
    } else {
      msgAlertaSemConfirmacao("Sem permissão para incluir!");
    }

  });

  $("#btnConsultar").on("click", async function () {
    await ConsultaNCM(true);
    $("#modal-filtros").modal("hide");
  });

  $("#btnLimparFiltros").on("click", async function () {
    $("#txtNCMconsulta").val("");
    $("#txtTipoConsulta").val("");
  });

  async function ConsultaNCM(bBotao = false) {
    try {
      let response;
      $.LoadingOverlay("show");
      let ncm =
        pegaChave("#txtNCMconsulta") != ""
          ? ` AND CODIGO = '${pegaChave("#txtNCMconsulta")}'`
          : "";
      let tipo =
        $("#txtTipoConsulta").val() != ""
          ? ` AND TIPO LIKE '[PERCENTUAL]${$(
            "#txtTipoConsulta"
          ).val()}[PERCENTUAL]'`
          : "";

      if (bBotao) {
        response = await requisicao(
          "GET",
          "/Sisplan/Funcoes/V1/pesquisa?",
          `JSON={ "tabela":"tabfis", "camposSelect":[ "codigo", "descricao", "tipo", "observacao"], "where": ["1=1 ${ncm} ${tipo}"]}`,
          null
        );
      } else {
        response = await requisicao(
          "GET",
          "/Sisplan/Funcoes/V1/pesquisa?",
          'JSON={ "tabela":"tabfis", "camposSelect":[ "codigo", "descricao", "tipo", "observacao"], "where": null}',
          null
        );
      }

      if (!response) {
        $.LoadingOverlay("hide");
        return;
      }

      let jsonStr = await response.json();
      if (response.status != 200) {
        $.LoadingOverlay("hide");
        msgErro(jsonStr.RESULT[0].mensagem);
        return;
      }

      $("#tabelaClaFiscal").DataTable({
        destroy: true,
        lengthChange: false,
        serverside: true,
        autoWidth: true,
        data: jsonStr.RESULT[0],
        columns: [
          {
            data: "CODIGO",
          },
          {
            data: "DESCRICAO",
          },
          {
            data: "TIPO",
          },
          {
            data: "OBSERVACAO"
          }
        ],
        columnDefs: [
          {
            targets: [0], render: function (data, type, row) {
              return retornaBotaoOpcoes(data);
            }
          },
        ],
      });

      $.LoadingOverlay("hide");
    } catch (error) {
      console.error(error);
      $.LoadingOverlay("hide");
    }
  }
  $("#tabelaClaFiscal").on("click", "#btn-editar", async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaClaFiscal").DataTable().row($(this).parents("tr")).data();
      let registroLiberado = await verificarRegistro("CLAFISCAL", data.CODIGO);
      if (registroLiberado) {
        window.location.href = `clafiscal/${data.CODIGO}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }

  });

  $("#tabelaClaFiscal").on("dblclick", "tr", async function () {
    if (permissaoUsuarioLogado.ALTERA == 'S') {
      let data = $("#tabelaClaFiscal").DataTable().row($(this)).data();
      let registroLiberado = await verificarRegistro("CLAFISCAL", data.CODIGO);
      if (registroLiberado) {
        window.location.href = `clafiscal/${data.CODIGO}`;
      }
    } else {
      msgAlertaSemConfirmacao("Sem permissão para alterar!");
    }

  });

  $('#tabelaClaFiscal').on('click', '#btn-excluir', async function () {
    if (permissaoUsuarioLogado.EXCLUI == 'S') {
      msgAlerta('Você realmente deseja excluir esse registro?', async () => {
        const data = $("#tabelaClaFiscal").DataTable().row($(this).parents("tr"));
        await excluiRegistro(data);
      });
    } else {
      msgAlertaSemConfirmacao("Sem permissão para excluir!");
    }

  });

  async function excluiRegistro(data) {
    try {
      $.LoadingOverlay("show");
      try {
        let valorLinha = data.data();
        let response = await requisicao("DELETE", "/Sisplan/Cadastros/v1/clafiscal?", `CODIGOCLAFISCAL=${encodeURIComponent(valorLinha.CODIGO)}`, null);
        if (!response) {
          return;
        }
        if (response.status != 200) {
          let jsonStr = await response.json();
          msgErro(jsonStr.mensagem);
          return;
        }

        toastr.success("Exclusão efetuada com sucesso!", "Confirmação", {
          toastClass: "success",
          iconClasses: {
            error: "alert-error",
            info: "alert-info",
            success: "alert-success",
            warning: "alert-warning",
          },
          positionClass: "toast-top-center",
          progressBar: true,
          timeOut: 3000,
          fadeOut: 1000,
          onHidden() {
            data.remove().draw(false);
          },
        }).css({
          "margin-top": "20%",
          width: "500px",
          "max-width": "500px",
        });

      } catch (error) {
        console.error(error);
      }
    } finally {
      $.LoadingOverlay("hide");
    }
  }
});

$("#tutorial").on("click", function () {
  $(document).ready(async function () {
    const driver = new Driver({
      doneBtnText: "Sair",
      closeBtnText: "Fechar",
      nextBtnText: "Próximo",
      prevBtnText: "Anterior",
      allowClose: false,
    });
    driver.defineSteps([
      {
        element: "#btnFiltros",
        popover: {
          title: "Botão Filtros",
          description: "Clique aqui para filtrar a consulta.",
          position: "right",
        },
      },
      {
        element: "#btnNovaClaFiscal",
        popover: {
          title: "Botão Incluir",
          description:
            "Clique aqui para iniciar o cadastro de uma Classificação Fiscal.",
          position: "right",
        },
      },
      {
        element: "#tabelaClaFiscal",
        popover: {
          title: "Tabela de Classificações Fiscais",
          description: "Aqui estão todas as classificações cadastradas.",
          position: "top",
        },
      },
    ]);
    driver.start();
  });
});
